VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.ocx"
Begin VB.Form Form1 
   Caption         =   "DirDescender Demo"
   ClientHeight    =   7125
   ClientLeft      =   120
   ClientTop       =   420
   ClientWidth     =   8340
   BeginProperty Font 
      Name            =   "Microsoft Sans Serif"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   7125
   ScaleWidth      =   8340
   StartUpPosition =   2  'CenterScreen
   Begin VB.CheckBox chkReturnRelativePaths 
      Caption         =   "Return Relative Paths"
      Enabled         =   0   'False
      Height          =   315
      Left            =   3420
      TabIndex        =   4
      Top             =   960
      Width           =   2775
   End
   Begin VB.TextBox txtDepth 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1020
      TabIndex        =   2
      Text            =   "0"
      Top             =   960
      Width           =   495
   End
   Begin VB.CheckBox chkReturnDirectories 
      Caption         =   "Return Directories"
      Height          =   315
      Left            =   3420
      TabIndex        =   3
      Top             =   540
      Width           =   2775
   End
   Begin RichTextLib.RichTextBox rtbLog 
      Height          =   5055
      Left            =   0
      TabIndex        =   8
      TabStop         =   0   'False
      Top             =   2040
      Width           =   8295
      _ExtentX        =   14631
      _ExtentY        =   8916
      _Version        =   393217
      Enabled         =   -1  'True
      ReadOnly        =   -1  'True
      ScrollBars      =   3
      TextRTF         =   $"Form1.frx":0000
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.TextBox txtPattern 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1020
      TabIndex        =   1
      Text            =   "*"
      Top             =   510
      Width           =   2115
   End
   Begin VB.CommandButton cmdSearch 
      Caption         =   "Search"
      Height          =   495
      Left            =   1020
      TabIndex        =   5
      Top             =   1440
      Width           =   1215
   End
   Begin VB.TextBox txtPath 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1020
      TabIndex        =   0
      Top             =   60
      Width           =   5235
   End
   Begin VB.Label Label4 
      Caption         =   "Depth"
      Height          =   255
      Left            =   60
      TabIndex        =   10
      Top             =   1020
      Width           =   975
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Center
      Caption         =   "Log Hidden For Speed"
      BeginProperty Font 
         Name            =   "Microsoft Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2783
      TabIndex        =   9
      Top             =   2400
      Width           =   2775
   End
   Begin VB.Label Label2 
      Caption         =   "Pattern"
      Height          =   255
      Left            =   60
      TabIndex        =   7
      Top             =   570
      Width           =   975
   End
   Begin VB.Label Label1 
      Caption         =   "Path"
      Height          =   255
      Left            =   60
      TabIndex        =   6
      Top             =   90
      Width           =   975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Log(ByVal Text As String)
    With rtbLog
        .SelStart = &H7FFFFFFF
        .SelText = Text
        .SelText = vbNewLine
    End With
End Sub

Private Sub chkReturnDirectories_Click()
    If chkReturnDirectories.Value = vbChecked Then
        chkReturnRelativePaths.Enabled = True
    Else
        chkReturnRelativePaths.Enabled = False
        chkReturnRelativePaths.Value = vbUnchecked
    End If
End Sub

Private Sub cmdSearch_Click()
    Dim AttrsDesired As DLFileAttribute
    Dim FileOrFolder As String
    Dim Counter As Long
    
    rtbLog.Text = ""
    AttrsDesired = dlNormal
    If chkReturnDirectories.Value = vbChecked Then
        If chkReturnRelativePaths.Value = vbChecked Then
            AttrsDesired = AttrsDesired Or dlDirectory Or dlRelativePaths
        Else
            AttrsDesired = AttrsDesired Or dlDirectory
        End If
    End If
    With DirLister
        .Start txtPath.Text, AttrsDesired, txtPattern.Text, CInt(txtDepth.Text)
        rtbLog.Visible = False
        MousePointer = vbHourglass
        Refresh
        Do While .Dir(FileOrFolder)
            Log FileOrFolder
            Counter = Counter + 1
        Loop
        Log "Done, " & CStr(Counter) & " names reported"
        .Finish
        rtbLog.Visible = True
        MousePointer = vbDefault
    End With
End Sub

Private Sub Form_Load()
    txtPath.Text = App.Path
End Sub

Private Sub Form_Resize()
    If WindowState <> vbMinimized Then
        With rtbLog
            .Move 0, .Top, ScaleWidth, ScaleHeight - .Top
        End With
        With txtPath
            .Width = ScaleWidth - .Left - ScaleX(4, vbPixels, ScaleMode)
        End With
    End If
End Sub
